#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cubix.h"


void panic (char*s)
{
  printf ("error: %s\n", s);
  exit(-1);
}

/* callback function to set a number variable */
void my_setnumber (char* name, double value)
{
  /* do nothing */
}

/* callback function to set a string variable */
void my_setstring (char* name, char* string)
{
  /* do nothing */
}

/* callback function to get value of a number variable */
double my_getnumber (char* name)
{
  if (!strcasecmp(name, "version")) return 0.73;
  return 0;
}

/* callback function to get value of a string variable */
char *my_getstring (char* name)
{
  //printf ("\n****** REQ: %s\n\n", name); 
  if (!strcasecmp(name, "app$")) return "Cubix Shell";
  return "(unknown)";
}

int main (int argc, char *argv[])
{
  char* sourcefile;
  struct CXContext mycontext;
  struct CXContext *cx = &mycontext;
  extern int cubix_malloc_count;

  /* set sourcefile if there's an argument */
  sourcefile = (char*) 0L;
  if (argc > 1) sourcefile = argv[1];

  /* intialize the context, never forget to do this ! */
  CXInitialize(cx);

  /* set callback functions */  
  cx->error_function = panic;
  cx->setnumber_function = my_setnumber;
  cx->setstring_function = my_setstring;
  cx->getnumber_function = my_getnumber;
  cx->getstring_function = my_getstring;

  /* compile source file */
  CXCompile (cx, sourcefile);

  /* execute source file */
  //CXExecute(cx);

  CXExecuteSub(cx, "onclick");

  /* release the context as finalization */
  CXRelease(cx);

  // check for memory leaks
  //printf ("malloc count=%d\n", cubix_malloc_count);

  return 0;
}
